<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.ExtensionsFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.Registry"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.service.ServiceControllerAction"
	import="net.sf.basedb.clients.web.extensions.service.Services"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
String cmd = request.getParameter("cmd");

DbControl dc = sc.newDbControl();

JspContext jspContext = ExtensionsControl.createContext(dc, pageContext);
ExtensionsInvoker<ServiceControllerAction> invoker = 
	(ExtensionsInvoker<ServiceControllerAction>)ExtensionsControl.useExtensions(jspContext, 
	(ExtensionsFilter)null, Services.EXTENSION_POINT_ID);
ExtensionsControl ec = ExtensionsControl.get(dc);
boolean writePermission = ec.hasPermission(Permission.WRITE);
ActionIterator<ServiceControllerAction> it = invoker.iterate();
int numServices = 0;

try
{
	%>
	<base:page title="Manage Services">
	<base:head scripts="table.js,~services.js" styles="table.css" />
	<base:body>
	<h1>Manage Services</h1>
	<div class="content">
		<tbl:table 
			id="services"
			subclass="fulltable topborder"
			columns="all"
			>
			<tbl:columndef 
				id="extension"
				title="Extension" 
			/>
			<tbl:columndef 
				id="service"
				title="Service" 
			/>
			<tbl:columndef 
				id="status"
				title="Status" 
			/>
			<tbl:columndef 
				id="actions"
				title="Actions" 
			/>
			<tbl:data style="top: 0px;  margin-top: 0px;">
				<tbl:headers>
					<tbl:headerrow>
						<tbl:columnheaders />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
				<%
				Extension last = null;
				while (it.hasNext())
				{
					numServices++;
					ServiceControllerAction action = it.next();
					Extension ext = it.getExtension();
					boolean isNewExtension = ext != last;
					last = ext;
					boolean isRunning = action.isRunning();
					Throwable error = isRunning ? null : ec.getLastExtensionError(ext.getId());
					boolean hasError = error != null;
					%>
					<tbl:row>
						<tbl:cell column="extension">
							<%
							if (isNewExtension)
							{
								%>
								<%=ext.getId()%>
								<%
							}
							%>
							</tbl:cell>
						<tbl:cell column="service"><%=action.toString()%></tbl:cell>
						<tbl:cell column="status">
							<%
							if (hasError)
							{
								%>
								<div class="messagecontainer error">
								<base:icon
									id="<%="toggle-stacktrace."+ext.getId()%>"
									subclass="auto-init"
									data-auto-init="toggle-stacktrace"
									data-extension-id="<%=ext.getId() %>"
									image="error.png" 
									style="float: left;"
									tooltip="Error - click to show full stack trace"
								/><%=error.getMessage() %>
								<div id="stacktrace.<%=ext.getId()%>"
										class="stacktrace"
										style="display: none;"
									><%=ThrowableUtil.stackTraceToString(error)%></div>
								</div>
								<%
							}
							else
							{
								%>
								<%=isRunning ? "Running" : "Stopped"%>
								<%
							}
							%>
						</tbl:cell>
						<tbl:cell column="actions">
							<%
							if (isNewExtension && writePermission)
							{
								if (isRunning)
								{
									%>
									<base:icon
										id="<%="stop."+ext.getId()%>" 
										subclass="auto-init"
										data-auto-init="control-service"
										data-cmd="Stop"
										data-extension-id="<%=ext.getId()%>"
										image="stop.png" 
										tooltip="Stop all services in this extension"
									/>
									<%
								}
								else
								{
									%>
									<base:icon 
										id="<%="start."+ext.getId()%>" 
										subclass="auto-init"
										data-auto-init="control-service"
										data-cmd="Start"
										data-extension-id="<%=ext.getId()%>"
										image="start.png" 
										tooltip="Start all services in this extension"
									/>
									<%
								}
							}
							%>
						</tbl:cell>
					</tbl:row>
					<%
				}
				if (numServices == 0)
				{
					%>
					<tbl:panel clazz="messagepanel">
						<div class="messagecontainer note">No services are installed</div>
					</tbl:panel>	
					<%
				}
				%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
	</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
