<%-- $Id: list_members.jsp 6482 2014-06-13 12:11:12Z olle $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/
	
	BASE is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.
	
	BASE is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.BioMaterialList"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioSource"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.List"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final int bioMaterialListId = Values.getInt(request.getParameter("list_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, Item.BIOMATERIALLIST);
final String ID = sc.getId();
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("member", "members");
final DbControl dc = sc.newDbControl();

ItemResultIterator<? extends BioMaterial> members = null;
try
{
	final BioMaterialList list = BioMaterialList.getById(dc, bioMaterialListId);
	final Item itemType = list.getMemberType();

	final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST, "listmembers."+list.getId());
	final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, "listmembers."+list.getId(), null, null);

	
	final boolean addPermission = list.hasPermission(Permission.WRITE);
	final boolean removePermission = addPermission;

	// Parent samples
	final ItemQuery<Sample> parentSamplesQuery = Sample.getQuery();
	parentSamplesQuery.join(Hql.innerJoin("childCreationEvents", "cce"));
	parentSamplesQuery.join(Hql.innerJoin("cce", "event", "evt"));
	parentSamplesQuery.restrict(Restrictions.eq(Hql.alias("evt"), Hql.entityParameter("creationEvent", Item.BIOMATERIALEVENT)));
	parentSamplesQuery.order(Orders.asc(Hql.property("name")));
	parentSamplesQuery.include(cc.getInclude());

	// Parent extracts
	final ItemQuery<Extract> parentExtractsQuery = Extract.getQuery();
	parentExtractsQuery.join(Hql.innerJoin("childCreationEvents", "cce"));
	parentExtractsQuery.join(Hql.innerJoin("cce", "event", "evt"));
	parentExtractsQuery.restrict(Restrictions.eq(Hql.alias("evt"), Hql.entityParameter("creationEvent", Item.BIOMATERIALEVENT)));
	parentExtractsQuery.order(Orders.asc(Hql.property("name")));
	parentExtractsQuery.include(cc.getInclude());

	// Child samples
	final ItemQuery<Sample> childSamplesQuery = Sample.getQuery();
	childSamplesQuery.order(Orders.asc(Hql.property("name")));
	childSamplesQuery.include(cc.getInclude());
	if (itemType == Item.BIOSOURCE)
	{
		childSamplesQuery.restrict(Restrictions.eq(Hql.property("parent"), Hql.entityParameter("parent", Item.BIOSOURCE)));
	}
	else
	{
		childSamplesQuery.join(Hql.innerJoin("creationEvent", "ce"));
		childSamplesQuery.join(Hql.innerJoin("ce", "sources", "src"));
		childSamplesQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Hql.entityParameter("parent", Item.SAMPLE)));
	}
	
	// Child extracts
	final ItemQuery<Extract> childExtractsQuery = Extract.getQuery();
	childExtractsQuery.include(cc.getInclude());
	childExtractsQuery.order(Orders.asc(Hql.property("name")));
	if (itemType == Item.SAMPLE)
	{
		childExtractsQuery.restrict(Restrictions.eq(Hql.property("parent"), Hql.entityParameter("parent", Item.SAMPLE)));
	}
	else
	{
		childExtractsQuery.join(Hql.innerJoin("creationEvent", "ce"));
		childExtractsQuery.join(Hql.innerJoin("ce", "sources", "src"));
		childExtractsQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Hql.entityParameter("parent", Item.EXTRACT)));
	}

	// Child bioassays
	final ItemQuery<PhysicalBioAssay> bioAssayQuery = PhysicalBioAssay.getQuery();
	bioAssayQuery.join(Hql.innerJoin("creationEvent", "ce"));
	bioAssayQuery.join(Hql.innerJoin("ce", "sources", "src"));
	bioAssayQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Hql.entityParameter("extract", Item.EXTRACT)));
	bioAssayQuery.order(Orders.asc(Hql.property("name")));
	bioAssayQuery.include(cc.getInclude());

	Unit microGram = UnitUtil.getUnit(dc, Quantity.MASS, "µg");
	final Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	final ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	final ItemResultList<AnnotationType> annotationTypes = annotationTypeQuery.list(dc);
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	try
	{
		final ItemQuery<? extends BioMaterial> query = list.getMemberBioMaterials();
		cc.configureQuery(dc, query, true);
		members = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Number> numericFormatter = FormatterFactory.getNumberFormatter(sc);
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);

	Enumeration<String, String> wellRows = new Enumeration<String, String>();
	ItemQuery<PlateGeometry> geometryQuery = PlateGeometry.getQuery();	
	geometryQuery.order(Orders.desc(Hql.property("rows")));
	ItemResultIterator<PlateGeometry> result = geometryQuery.iterate(dc);
	int maxRows = result.next().getRows();
	for (int r = 0; r < maxRows && r < 256; r++)
	{
		wellRows.add(Integer.toString(r), rowFormatter.format(r));
	}

	Enumeration<String, String> wellColumns = new Enumeration<String, String>();
	ItemQuery<PlateGeometry> columnsGeometryQuery = PlateGeometry.getQuery();	
	columnsGeometryQuery.order(Orders.desc(Hql.property("columns")));
	ItemResultIterator<PlateGeometry> columnsResult = columnsGeometryQuery.iterate(dc);
	int maxColumns = columnsResult.next().getColumns();
	for (int c = 0; c < maxColumns && c < 256; c++)
	{
		wellColumns.add(Integer.toString(c), columnFormatter.format(c));
	}

	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, list);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="table.js,tabcontrol-2.js,~members.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<p:path><p:pathelement 
			title="Biomaterial lists" href="<%="../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(list.getName())%>" 
			/></p:path>
		<div id="page-data" class="datacontainer"
			data-item-type="<%=itemType.name()%>"
			></div>
		<t:tabcontrol 
			id="main"
			subclass="content mastertabcontrol"
			active="members">
		<t:tab id="properties" title="Properties" />
		
		<t:tab id="members" title="Members">

		<tbl:table 
			id="members" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%="listmembers."+list.getId()%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:hidden 
				name="list_id" 
				value="<%=String.valueOf(bioMaterialListId)%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="itemSubtype"
				property="itemSubtype"
				sortproperty="itemSubtype.name"
				exportproperty="itemSubtype.name:string"
				datatype="int"
				enumeration="<%=Enumeration.fromItems(subtypesQuery.list(dc), "-none-")%>"
				title="Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
			   id="id"
				clazz="uniquecol"
			   property="id"
			   datatype="int"
			   title="ID"
			   sortable="true" 
			   filterable="true"
			   exportable="true"
			/>
			<tbl:columndef 
				id="externalId"
				property="externalId"
				datatype="string"
				title="External id"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<%
			if (itemType == Item.BIOSOURCE)
			{
				%>
				<tbl:columndef 
					id="entryDate"
					property="entryDate"
					datatype="date"
					title="Registered"
					sortable="true" 
					filterable="true"
					exportable="true"
					formatter="<%=dateFormatter%>"
				/>
				<tbl:columndef
					id="children"
					title="Child samples"
					property="&children(name)"
					datatype="string"
					filterable="true"
					exportable="true"
				/>
				<%
			}
			if (itemType == Item.SAMPLE || itemType == Item.EXTRACT)
			{
				%>
				<tbl:columndef 
					id="originalQuantity"
					property="originalQuantity"
					datatype="float"
					title="Original quantity (µg)"
					sortable="true" 
					filterable="true"
					exportable="true"
					unit="<%=microGram%>"
					formatter="<%=numericFormatter%>"
				/>
				<tbl:columndef 
					id="remainingQuantity"
					property="remainingQuantity"
					datatype="float"
					title="Remaining quantity (µg)"
					sortable="true" 
					filterable="true"
					exportable="true"
					unit="<%=microGram%>"
					formatter="<%=numericFormatter%>"
				/>
				<tbl:columndef 
					id="protocol"
					property="creationEvent.protocol"
					sortproperty="creationEvent.protocol.name"
					filterproperty="creationEvent.protocol.name"
					exportproperty="creationEvent.protocol.name"
					datatype="string"
					title="Protocol"
					sortable="true" 
					filterable="true"
					exportable="true"
				/>
				<tbl:columndef 
					id="eventDate"
					property="creationEvent.eventDate"
					datatype="date"
					title="Created"
					sortable="true" 
					filterable="true"
					exportable="true"
					formatter="<%=dateFormatter%>"
				/>
				<tbl:columndef 
					id="entryDate"
					property="creationEvent.entryDate"
					datatype="date"
					title="Registered"
					sortable="true" 
					filterable="true"
					exportable="true"
					formatter="<%=dateFormatter%>"
				/>
				<%
				Enumeration<String, String> parentTypes = new Enumeration<String, String>();
				parentTypes.add("", "-none-");
				if (itemType == Item.SAMPLE)
				{
					parentTypes.add(Integer.toString(Item.BIOSOURCE.getValue()), Item.BIOSOURCE.toString());
				}
				parentTypes.add(Integer.toString(Item.SAMPLE.getValue()), Item.SAMPLE.toString());
				if (itemType == Item.EXTRACT)
				{
					parentTypes.add(Integer.toString(Item.EXTRACT.getValue()), Item.EXTRACT.toString());
				}
				%>
				<tbl:columndef
					id="parentType"
					title="Parent type"
					property="parentType"
					enumeration="<%=parentTypes%>"
					datatype="int"
					filterable="true"
					exportable="true"
					sortable="true"
				/>
				<tbl:columndef
					id="parents"
					title="Parent items"
					property="&creationEvent.sources(bioMaterial.name)"
					sortproperty="parent.name"
					datatype="string"
					filterable="true"
					exportable="true"
					sortable="true"
				/>
				<%
				if (itemType == Item.SAMPLE)
				{
					%>
					<tbl:columndef
						id="children"
						title="Child samples"
						property="&childCreationEvents(event.bioMaterial.name)"
						datatype="string"
						filterable="true"
						exportable="true"
					/>
					<tbl:columndef
						id="extracts"
						title="Child extracts"
						property="&children(name)"
						datatype="string"
						filterable="true"
						exportable="true"
					/>
					<%
				}
				else
				{
					%>
					<tbl:columndef
						id="children"
						title="Child extracts"
						property="&childCreationEvents(event.bioMaterial.name)"
						datatype="string"
						filterable="true"
						exportable="true"
					/>
					<tbl:columndef
						id="physicalBioAssays"
						title="Physical bioassays"
						property="&childCreationEvents(event.physicalBioAssay.name)"
						datatype="string"
						filterable="true"
						exportable="true"
					/>
					<tbl:columndef 
						id="tag"
						property="tag.name"
						datatype="string"
						title="Tag"
						sortable="true" 
						filterable="true"
						exportable="true"
					/>
					<%
				}
				%>
				<tbl:columndef 
					id="bioPlate"
					property="bioWell.bioPlate.name"
					sortproperty="bioWell.bioPlate.name"
					filterproperty="bioWell.bioPlate.name"
					exportproperty="bioWell.bioPlate.name"
					datatype="string"
					title="Bioplate"
					sortable="true" 
					filterable="true"
					exportable="true"
				/>
				<tbl:columndef 
					id="bioWellRow"
					property="bioWell.row"
					sortproperty="bioWell.row"
					datatype="int"
					title="Biowell row"	 
					filterable="true"
					enumeration="<%=wellRows%>"
					exportable="true"
					sortable="true"
					formatter="<%=rowFormatter%>"
				/>
				<tbl:columndef 
					id="bioWellColumn"
					property="bioWell.column"
					sortproperty="bioWell.column"
					datatype="int"
					title="Biowell column"	 
					filterable="true"
					enumeration="<%=wellColumns%>"
					exportable="true"
					sortable="true"
					formatter="<%=columnFormatter%>"
				/>
				<%
			}
			%>
			<%
			for (AnnotationType at : annotationTypes)
			{
				Enumeration<String, String> annotationEnum = null;
				Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="at"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+" [A]"%>" 
					property="<%="#"+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						id="btnAddMembers"
						disabled="<%=addPermission ? false : true%>" 
						image="add.png" 
						title="Add&hellip;" 
						tooltip="<%=addPermission ? "Add more biomaterials to this list" : "You do not have permission to add biomaterial" %>" 
					/>
					<tbl:button 
						id="btnRemoveMembers"
						disabled="<%=removePermission ? false : true%>" 
						image="remove.png" 
						title="Remove&hellip;" 
						tooltip="<%=removePermission ? "Remove the selected items from this list" : "You do not have permission to remove items" %>" 
					/>
					<tbl:button 
						id="btnDeleteItems"
						image="delete.png"
						title="Delete" 
						tooltip="Delete the selected items" 
					/>
					<tbl:button 
						id="btnRestoreItems"
						image="restore.png"
						title="Restore" 
						tooltip="Restore the selected (deleted) items"
					/>
					<tbl:button 
						id="btnShareItems"
						image="share.png"
						title="Share&hellip;" 
						tooltip="Share the selected items"
					/>
					<tbl:button 
						id="btnSetOwner"
						image="take_ownership.png"
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button 
						id="btnPlaceOnPlate"
						image="place_on_plate.png" 
						title="Place on plate&hellip;" 
						tooltip="Place the selected/matching biomaterial on a bioplate" 
						visible="<%=itemType != Item.BIOSOURCE%>"
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=members == null ? 0 : members.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasCheck()%>"
							><base:icon 
								id="check.uncheck"
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							visible="<%=mode.hasIcons()%>"
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (members != null)
					{						
						while (members.hasNext())
						{
							BioMaterial item = members.next();
							int itemId = item.getId();
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							
							MeasuredBioMaterial mbm = null;
							BioMaterialEvent creationEvent = null;
							Item parentType = null;
							
							if (item instanceof MeasuredBioMaterial)
							{
								mbm = (MeasuredBioMaterial)item;
								creationEvent = mbm.getCreationEvent();
								parentType = mbm.getParentType();
							}
							
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							String name = HTML.encodeTags(item.getName());
							String tooltip = mode.isSelectionMode() ?
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.png"
										id="<%="delete."+itemId %>"
										subclass="<%=deletePermission ? "table-delete-item" : null %>"
										data-item-id="<%=itemId%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="shared.png" 
										id="<%="share."+itemId %>"
										subclass="<%=sharePermission ? "table-share-item" : null %>"
										data-item-id="<%=itemId%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div
									class="link table-item"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>" 
									tabindex="0"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="itemSubtype"><base:propertyvalue 
										item="<%=item%>" 
										property="itemSubtype"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="externalId"><%=HTML.encodeTags(item.getExternalId())%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<%
								if (itemType == Item.BIOSOURCE)
								{
									%>
									<tbl:cell column="entryDate" value="<%=((BioSource)item).getEntryDate()%>" />
									<%
								}
								if (mbm != null)
								{
									%>
									<tbl:cell column="originalQuantity" value="<%=mbm.getOriginalQuantity()%>" />
									<tbl:cell column="remainingQuantity" value="<%=mbm.getRemainingQuantity()%>" />
									<tbl:cell column="protocol"
										><base:propertyvalue 
											item="<%=creationEvent%>" 
											property="protocol"
											enableEditLink="<%=mode.hasEditLink()%>" 
											enablePropertyLink="<%=mode.hasPropertyLink()%>"
										/></tbl:cell>
									<%								
									BioWell well = null;
									boolean readBioWell = true;
									try
									{
										well = mbm.getBioWell();
									}
									catch(PermissionDeniedException e)
									{
										readBioWell = false;
									}
									if (!readBioWell)
									{
										%>
										<tbl:cell column="bioWellRow"><i>- denied -</i> </tbl:cell>
										<tbl:cell column="bioWellColumn"><i>- denied -</i> </tbl:cell>
										<tbl:cell column="bioPlate"><i>- denied -</i> </tbl:cell>
										<%
									}
									else if (well == null)
									{
										%>
										<tbl:cell column="bioWellRow"><i>- none -</i> </tbl:cell>
										<tbl:cell column="bioWellColumn"><i>- none -</i> </tbl:cell>
										<tbl:cell column="bioPlate"><i>- none -</i> </tbl:cell>
										<%
										
									}
									else
									{								
										%>
										<tbl:cell column="bioWellRow">
											<tbl:cellvalue value="<%=well.getRow()%>"/>
										</tbl:cell>
										<tbl:cell column="bioWellColumn">
											<tbl:cellvalue value="<%=well.getColumn()%>"/>
										</tbl:cell>
										<tbl:cell column="bioPlate"><%=Base.getLinkedName(ID, well.getPlate(), false, true)%></tbl:cell>
										<%
									}
									%>
									<tbl:cell column="eventDate" value="<%=creationEvent.getEventDate()%>" />
									<tbl:cell column="entryDate" value="<%=creationEvent.getEntryDate()%>" />
									<tbl:cell column="parentType"><%=parentType == null ? "" : parentType.toString() %></tbl:cell>

									<tbl:cell column="parents">
										<%
										if (mbm.hasSingleParent() || parentType == null)
										{
											%>
											<base:propertyvalue item="<%=item%>" property="parent"/>
											<%
										}
										else
										{
											String separator = "";
											ItemQuery<MeasuredBioMaterial> parentsQuery = (ItemQuery<MeasuredBioMaterial>)(parentType == Item.SAMPLE ? parentSamplesQuery : parentExtractsQuery);
											parentsQuery.setEntityParameter("creationEvent", creationEvent);
											for (MeasuredBioMaterial s : parentsQuery.list(dc))
											{
												out.write(separator);
												if (mode.hasPropertyLink())
												{
													out.write(Base.getLinkedName(ID, s, false, mode.hasEditLink()));
												}
												else
												{
													out.write(HTML.encodeTags(s.getName()));
												}
												separator = ", ";
											}
										}
										%>
										<%=parentType != null ? "<span class=\"itemsubtype\">(" + parentType + ")</span>" : "" %>
									</tbl:cell>
									<%
								}
								%>
								<tbl:cell column="tag"
									><base:propertyvalue 
										item="<%=item%>" 
										property="tag"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="children">
									<%
									String separator = "";
									ItemQuery<MeasuredBioMaterial> childQuery = (ItemQuery<MeasuredBioMaterial>)(itemType == Item.EXTRACT ? childExtractsQuery : childSamplesQuery);
									childQuery.setEntityParameter("parent", item);
									for (MeasuredBioMaterial s : childQuery.list(dc))
									{
										out.write(separator);
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, s, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(s.getName()));
										}
										separator = ", ";
									}
									%>
								</tbl:cell>
								<tbl:cell column="extracts">
									<%
									childExtractsQuery.setEntityParameter("parent", item);
									try
									{
										String separator = "";
										for(Extract e : childExtractsQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, e, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(e.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="physicalBioAssays">
									<%									
									try
									{
										bioAssayQuery.setEntityParameter("extract", item);
										String separator = "";
										for (PhysicalBioAssay pba : bioAssayQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, pba, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(pba.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
								</tbl:cell>
								<%
								AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
								if (as != null)
								{
									for (AnnotationType at : annotationTypes)
									{
										if (as.hasAnnotation(at))
										{
											Annotation a = as.getAnnotation(at);
											String suffix = a.getUnitSymbol(null);
											if (suffix != null) suffix = "&nbsp;" + suffix;
											%>
											<tbl:cell 
												column="<%="at"+at.getId()%>"
												><tbl:cellvalue 
													list="<%=a.getValues(null)%>"
													suffix="<%=suffix%>"
											/></tbl:cell>
											<%
										}
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
							<%=members == null || members.getTotalCount() == 0 ? "No members were found" : "No members on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</t:tab>
		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items" />
		</t:tabcontrol>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>


	</base:body>
	</base:page>
	<%
}
finally
{
	if (members != null) members.close();
	if (dc != null) dc.close();
}
%>
