<%-- $Id: download_immediately.jsp 6372 2013-12-06 10:52:11Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006, 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.PluginResponse"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
PluginResponse pluginResponse = (PluginResponse)sc.getSessionSetting("plugin.configure.response");
String title = pluginResponse.getMessage() == null ? 
	"Download export" : HTML.encodeTags(pluginResponse.getMessage());
try
{
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head styles="progressbar.css" scripts="~download_immediately.js" />
	<base:body>
		<h1>Export items</h1>
		
		<div class="content">
			<table class="fullcc"><tr><td style="padding-left: 10em; padding-right: 10em;">
				<div id="beforeDownloadInfo" style="font-weight: bold;">
				The configuration has been successfully completed. 
				Click on the <code>Download</code> button to download the 
				exported data.
				</div>
				<div id="afterDownloadInfo" style="margin-top: 0.5em; font-weight: bold;">
				Do not close this window until the download has finished. 
				</div>
				
				<table id="download" style="margin: auto; margin-top: 1em;"><tr><td>
				<base:button id="btnDownload" title="Download" image="download.png" />
				</td></tr></table>
				
				<!-- The progress bar -->
				<div id="progress" style="align:center; margin-top: 2em; display: none;">
					<table class="progressbar" style="margin: auto;">
					<tr>
					<td>
						<table class="bar" style="width: 200px">
						<tr>
							<td style="width: 0%;" id="percentDone" class="percentDone">&nbsp;</td>
							<td style="width: 100%;" id="percentRemain" class="percentRemain">&nbsp;</td>
						</tr>
						</table>
					</td>
					<td id="percentText" class="percentText">0%</td>
					</tr>
					</table>
					<div id="message" style="font-style: italic;">Working...</div>
				</div>
		
			</td></tr></table>
		</div>
		

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnCancel" title="Cancel" />
			<base:button id="close" title="Close" style="display: none; "/>
		</base:buttongroup>
		
		<iframe id="downloadFrame" style="display: none;" ></iframe>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

