<%-- $Id: index.jsp 6308 2013-08-20 12:54:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileServer"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.core.SimpleProgressReporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,size,itemSubtype,description,actions");
	private static final ItemContext searchContext = Base.createDefaultContext("name", "path,name,size,description,actions");
	private static final Item itemType = Item.FILE;
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String subcontext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext dirContext = sc.getCurrentContext(Item.DIRECTORY);
final int directoryId = Values.getInt(request.getParameter("directory_id"), dirContext.getId());
dirContext.setId(directoryId);
final String listPage = "list_files.jsp?ID="+ID+"&directory_id="+directoryId
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId)
	+"&subcontext=" + subcontext;
final String viewPage = "view_file.jsp?ID="+ID;
final String editPage = "edit_file.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updating the current context
		Base.getAndSetCurrentContext(sc, itemType, subcontext, (PageContext)null, defaultContext, false);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		redirect = editPage;
	}
	else if ("EditMultiple".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		if (cc.getSelected().size() == 1)
		{
			cc.setId(cc.getSelected().iterator().next());
			redirect = editPage;
		}
		else
		{
			redirect = "edit_multiple_file.jsp?ID="+ID;
		}
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		cc.setId(0);
		redirect = editPage+"&directory_id="+directoryId;
	}
	else if ("UploadNewFile".equals(cmd))
	{
		// Display the upload page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		cc.setId(0);
		redirect = "../upload/index.jsp?ID="+ID+"&directory_id="+directoryId;
	}
	else if ("UploadFile".equals(cmd))
	{
		// Display the upload page for an existing item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		redirect = "../upload/index.jsp?ID="+ID+"&file_id=" +itemId;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, null, defaultContext);
		final int maxRecent = Base.getMaxRecent(sc);
		dc = sc.newDbControl();
		File file = (File)cc.getObject("item");
		if (file == null)
		{
			file = File.getNew(dc, Directory.getById(dc, directoryId));
			message = "File created";
			file.setLocation(Location.EXTERNAL);
			dc.saveItem(file);
		}
		else
		{
			dc.reattachItem(file, false);
			message = "File updated";
		}
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.FILE), file);
		ExtensionsInvoker invoker = EditUtil.useOnSaveExtensions(jspContext);
		try
		{
			file.setName(Values.getStringOrNull(request.getParameter("name")));
			file.setMimeType(Values.getStringOrNull(request.getParameter("mime_type")));
			file.setCharacterSet(Values.getStringOrNull(request.getParameter("characterSet")));
			file.setWriteProtected(Values.getBoolean(request.getParameter("write_protected"), false));
			file.setDescription(Values.getStringOrNull(request.getParameter("description")));
			
			int subtypeId = Values.getInt(request.getParameter("subtype_id"), -1);
			if (subtypeId >= 0) // < 0 = denied or unchanged
			{
				ItemSubtype subtype = subtypeId == 0 ? null : ItemSubtype.getById(dc, subtypeId);
				file.setItemSubtype(subtype);
				if (subtype != null) cc.setRecent(subtype, maxRecent);
			}

			if (file.getLocation() == Location.EXTERNAL)
			{
				boolean loadMetadata = Values.getBoolean(request.getParameter("loadMetadata"));
				int serverId = Values.getInt(request.getParameter("server_id"), -1);
				if (serverId >= 0) // < 0 = denied or unchanged
				{
					FileServer server = serverId == 0 ? null : FileServer.getById(dc, serverId);
					file.setFileServer(server);
					if (server != null) cc.setRecent(server, maxRecent);
				}
				file.setUrl(Values.getStringOrNull(request.getParameter("url")), loadMetadata);
			}
			
			// OnSave extensions
			invoker.render(OnSaveRenderer.ON_SAVE);
			dc.commit();
			invoker.render(OnSaveRenderer.ON_COMMIT);
		}
		catch (Exception ex)
		{
			invoker.render(OnSaveRenderer.onRollback(ex));
			throw ex;
		}
		finally
		{
			cc.removeObject("item");
		}
	}
	else if ("UpdateMultipleItems".equals(cmd))
	{
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, null, defaultContext);
		boolean setWriteProtected = !"keep".equals(request.getParameter("write_protected"));
		boolean writeProtected = Values.getBoolean(request.getParameter("write_protected"));
		int fileTypeId = Values.getInt(request.getParameter("filetype_id"), -1);
		boolean setFileType = fileTypeId >= 0;
		ItemSubtype fileType = setFileType && fileTypeId > 0 ? ItemSubtype.getById(dc, fileTypeId) : null;
		boolean setCharacterSet = !"keep".equals(request.getParameter("characterSet"));
		String characterSet = Values.getStringOrNull(request.getParameter("characterSet"));
		boolean setMimeType = !Values.getBoolean(request.getParameter("keepMimeType"));
		String mimeType = Values.getStringOrNull(request.getParameter("mimeType"));
		
		int numSelected = cc.getSelected().size();
		int numUpdated = 0;
		if (setWriteProtected || setFileType || setCharacterSet || setMimeType)
		{
			for (int fileId : cc.getSelected())
			{
				File file = File.getById(dc, fileId);
				if (file.hasPermission(Permission.WRITE))
				{
					if (setWriteProtected) file.setWriteProtected(writeProtected);
					if (setFileType) file.setItemSubtype(fileType);
					if (setCharacterSet) file.setCharacterSet(characterSet);
					if (setMimeType) file.setMimeType(mimeType);
					numUpdated++;
				}
			}
		}
		dc.commit();
		message = numUpdated + " of " + numSelected + " files updated";
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		int numTotal = cc.getSelected().size()+dirContext.getSelected().size();
		int[] numRemoved = RemovableUtil.removeRecursively(dc, Item.DIRECTORY, dirContext.getSelected(), true);
		numRemoved[0] += RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		numTotal += numRemoved[1];		
		dc.commit();
		if (numTotal != numRemoved[0])
		{
			message = (numRemoved[0] == 0 ? "No" : "Only "+numRemoved[0]+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage;
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		RemovableUtil.removeRecursively(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		int numTotal = cc.getSelected().size()+dirContext.getSelected().size();
		int numRemoved = 0;
		int[] numDirRemoved = RemovableUtil.removeRecursively(dc, Item.DIRECTORY, dirContext.getSelected(), false);
		int[] numFileRemoved = RemovableUtil.removeRecursively(dc, itemType, cc.getSelected(), false);
		numTotal += numDirRemoved[1] + numFileRemoved[1];
		numRemoved = numDirRemoved[0] + numFileRemoved[0];
		
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage;
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subcontext;
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		
		Set<SharedItem> items = new HashSet<SharedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add(File.getById(dc, id));
		}
		for (Integer id : dirContext.getSelected())
		{
			if (id != null) items.add(Directory.getById(dc, id));
		}
		
		MultiPermissions permissions = new MultiPermissions(items);
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subcontext;
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add(File.getById(dc, id));
		}
		for (Integer id : dirContext.getSelected())
		{
			if (id != null) items.add(Directory.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subcontext;
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		dc.close();
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name()+"&subcontext="+subcontext;
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		final ItemQuery<File> query = File.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		ExtensionsInvoker listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer(cc));
		dc.close();
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subcontext+"&context_type=LIST&title=Export+files";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subcontext+"&context_type=ITEM&title=Export+file";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		final ItemQuery<File> query = File.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subcontext+"&context_type=LIST&title=Import+files";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subcontext+"&context_type=ITEM&title=Import+file";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		final ItemQuery<File> query = File.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subcontext+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&subcontext="+subcontext+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("MoveItems".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		int numMoved = 0;
		int numTotal = cc.getSelected().size();
		Location moveTo = Location.valueOf(request.getParameter("move"));
		
		dc = sc.newDbControl();
		for (Integer id : cc.getSelected())
		{
			File f = File.getById(dc, id);
			Location current = f.getLocation();
			try
			{
				if (moveTo == Location.OFFLINE && current != Location.OFFLINE)
				{
					// 0 = move offline
					f.setLocation(Location.OFFLINE);
					f.setAction(File.Action.NOTHING);
					numMoved++;
				}
				else if (moveTo == Location.PRIMARY)
				{
					// 1 = move to primary
					f.setAction(current == Location.PRIMARY ? File.Action.NOTHING : File.Action.MOVE_TO_PRIMARY);
					numMoved++;
				}
				else if (moveTo == Location.SECONDARY)
				{
					// 2 = move to secondary
					f.setAction(current == Location.SECONDARY ? File.Action.NOTHING : File.Action.MOVE_TO_SECONDARY);
					numMoved++;
				}
			}
			catch (PermissionDeniedException ex)
			{}
			dc.commit();
		}
		if (numTotal != numMoved)
		{
			message = (numMoved == 0 ? "No" : "Only "+numMoved+" of "+numTotal) + " items could be move, because you have no WRITE permission";
		}
		redirect = listPage;
	}
	else if ("MoveItem".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		Location moveTo = Location.valueOf(request.getParameter("move"));
		
		dc = sc.newDbControl();
		File f = File.getById(dc, cc.getId());
		Location current = f.getLocation();
		if (moveTo == Location.OFFLINE && current != Location.OFFLINE)
		{
			// 0 = move offline
			f.setLocation(Location.OFFLINE);
			f.setAction(File.Action.NOTHING);
		}
		else if (moveTo == Location.PRIMARY)
		{
			// 1 = move to primary
			f.setAction(current == Location.PRIMARY ? File.Action.NOTHING : File.Action.MOVE_TO_PRIMARY);
		}
		else if (moveTo == Location.SECONDARY)
		{
			// 2 = move to secondary
			f.setAction(current == Location.SECONDARY ? File.Action.NOTHING : File.Action.MOVE_TO_SECONDARY);
		}
		dc.commit();
		redirect = viewPage;
	}
	else if ("MoveToDirectory".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		int numMoved = 0;
		int numTotal = cc.getSelected().size()+dirContext.getSelected().size();
		int newDirectoryId = Values.getInt(request.getParameter("newdirectory_id"));
		
		dc = sc.newDbControl();
		Directory newDirectory = Directory.getById(dc, newDirectoryId);
		for (Integer id : cc.getSelected())
		{
			try
			{
				File f = File.getById(dc, id);
				if (File.exists(dc, newDirectory, f.getName()))
				{
					throw new ItemAlreadyExistsException("Directory '" + newDirectory.getName() + "' already contains file: " + f.getName());
				}
				f.setDirectory(newDirectory);
				numMoved++;
			}
			catch (PermissionDeniedException ex)
			{}
		}
		
		for (Integer id : dirContext.getSelected())
		{
			try
			{
				Directory d = Directory.getById(dc, id);
				if (Directory.exists(dc, newDirectory, d.getName()))
				{
					throw new ItemAlreadyExistsException("Directory '" + newDirectory.getName() + "' already contains subdirectoy: " + d.getName());
				}
				d.setParent(newDirectory);
				numMoved++;
			}
			catch (PermissionDeniedException ex)
			{}
		}
		dc.commit();
		if (numTotal != numMoved)
		{
			message = (numMoved == 0 ? "No" : "Only "+numMoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage;
	}
	else if ("ViewFile".equals(cmd))
	{
		// View the file contents of a file
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		dc = sc.newDbControl();
		File f = File.getById(dc, cc.getId());
		redirect = root + "filemanager/files/view/-"+ID+"-"+ f.getPath().toURLString("UTF-8");
		dc.close();
	}
	else if ("DownloadFile".equals(cmd))
	{
		// Download the file contents of a file
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		forward = "download_file.jsp?ID="+ID;
	}
	else if ("CompressItem".equals(cmd))
	{
		// Compress a single item and then return to the view page
		SimpleProgressReporter progress = new SimpleProgressReporter(null);
		sc.setSessionSetting("progress.compress", progress);
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		File f = File.getById(dc, cc.getId());
		f.compress(progress);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DecompressItem".equals(cmd))
	{
		// Compress a single item and then return to the view page
		SimpleProgressReporter progress = new SimpleProgressReporter(null);
		sc.setSessionSetting("progress.decompress", progress);
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		File f = File.getById(dc, cc.getId());
		f.decompress(progress);
		dc.commit();
		redirect = viewPage;
	}
	else if ("EditFileData".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, pageContext, defaultContext);
		redirect = "edit_file_data.jsp?ID=" + ID;
	}
	else if ("Search".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, "search", pageContext, searchContext);
		redirect = listPage;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

